unit UFPuntuales;

interface

uses
   UProto, Graphics, math;

const
   _lamb   = 255;

   procedure FP_Negativo( Ma : Mat3D; var Mb : Mat3D);
   procedure FP_Suma    ( Ma : Mat3D; var Mb : Mat3D; rr : single);
   procedure FP_Gamma   ( Ma : Mat3D; var Mb : Mat3D; rr : single);

implementation

procedure FP_Negativo(Ma : Mat3D; var Mb : Mat3D);
var
  x,y,nx,ny,can : integer;
begin
  nx := Ma.nc;
  ny := Ma.nr;

  Mb.nc := nx;
  Mb.nr := ny;
  SetLength(Mb.dat,nx,ny,3);
  Mat2Mat(Ma,Mb);

  for can := 0 to 2 do
    if kan[can] then
      for x := _x1 to _x2-1 do
        for y := _y1 to _y2-1 do
          Mb.dat[x][y][can] := 255 - Ma.dat[x][y][can];
end;

procedure FP_Suma    ( Ma : Mat3D; var Mb : Mat3D; rr : single);
var
  x,y,nx,ny,can : integer;
begin
  nx := Ma.nc;
  ny := Ma.nr;

  Mb.nc := nx;
  Mb.nr := ny;
  SetLength(Mb.dat,nx,ny,3);
  Mat2Mat(Ma,Mb);

  for can := 0 to 2 do
   if kan[can] then
    for x := _x1 to _x2 - 1 do
      for y := _y1 to _y2 - 1 do
        Mb.dat[x][y][can] := Ma.dat[x][y][can] + rr;
   end;

// Gamma
procedure FP_Gamma   ( Ma : Mat3D; var Mb : Mat3D; rr : single);
var
  x,y,nx,ny,can : integer;
begin
  nx := Ma.nc;
  ny := Ma.nr;

  Mb.nc := nx;
  Mb.nr := ny;
  SetLength(Mb.dat,nx,ny,3);
  Mat2Mat(Ma,Mb);

  for can := 0 to 2 do
   if kan[can] then
    for x := _x1 to _x2 - 1 do
      for y := _y1 to _y2 - 1 do
        Mb.dat[x][y][can] := _lamb*power(Ma.dat[x][y][can]/_lamb,rr);
end;

end.
