unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms,  Dialogs, ExtCtrls, Menus, ComCtrls,
  UProto, UFPuntuales, gfx_files, StdCtrls, math;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Puntuales1: TMenuItem;
    Negativo1: TMenuItem;
    Suma1: TMenuItem;
    Gamma1: TMenuItem;
    Salvar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Opciones1: TMenuItem;
    Deshacer1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Image2: TImage;
    Bevel1: TBevel;
    RadioGroup1: TRadioGroup;
    StatusBar3: TStatusBar;
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Negativo1Click(Sender: TObject);
    procedure Suma1Click(Sender: TObject);
    procedure Gamma1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Image2MouseLeave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    nom      : string;
    M1,M2    :  Mat3D;
    nx,ny    : integer;
    BM1,BMS  : TBitMap;
    bopen    : boolean;
    bsel     : boolean;
    bTarSel  : boolean;
  end;

var
  Form1: TForm1;

implementation

uses UTomaDato;

{$R *.dfm}

// create
procedure TForm1.FormCreate(Sender: TObject);
begin
  bopen   := false;
  bsel    := false;
  bTarSel := false;

  // se crean los BitMaps de trabajo
  BM1 := TBitMap.Create;   // operativo
  BMS := TBitMap.Create;   // para la seleccion rectangular

  // preparamos el BitMap y la Imagen para la seleccion
  Image2.BringToFront;
  Image2.Transparent := true;
  Image2.AutoSize := true;
  BMS.Transparent := true;
  BMS.Width  := 2;
  BMS.Height := 2;
  BMS.TransparentColor := clWhite;
  with BMS.Canvas do begin
    Brush.Color := clWhite;
    Pen.Color   := clWhite;
    Rectangle(0,0,1,1);
    Pen.Color := clYellow;
    Pen.Width := 2;
  end;
  Image2.Picture.Assign(BMS);

  // Esconder Image1 e Image2 para que no aparezca el cuadro blanco
  Image1.Hide;
  Image2.Hide;

  // cambiamos el icono de la aplicacin
  Form1.Icon.LoadFromFile('bunny1.ico');

end;


// Abrir de Archivo
procedure TForm1.Abrir1Click(Sender: TObject);
begin
  // configuramos el filtro de tipo de archivo a abrir
  OpenDialog1.Filter := gfx_files._OpenFilterString;
  // se dispara el dialogo de seleccion de archivos
  if OpenDialog1.Execute then begin
    // capturamos el nombre del archivo seleccionado
    nom := OpenDialog1.FileName;
    // mandamos a la interface el nombre del archivo abierto
    StatusBar3.Panels[1].Text := nom;

    // cargamos el archivo seleccionado a un BitMap en Memoria
    gfx_files.LoadAnyImageToBMP(BM1,nom,false,0,0);

    // asignamos el BitMap a la interface
    Image1.Picture.Assign(BM1);
    // mandamos al Image en la interfase
    Image1.Show;

    // preparamos la Matriz de trabajo M1 para hacer las operaciones
    nx := Image1.Width;
    ny := Image1.Height;
    M1.nc := nx;
    M1.nr := ny;

    // ponemos la zona de seleccion a tamao completo
    _x1 := 0; _y1 := 0; _x2 := nx; _y2 := ny;

    BM2Mat(BM1,M1);  // lo copia a una matriz M[x][y][c]

    // limpiar y escalar zona de seleccion
    BMS.Width  := nx;
    BMS.Height := ny;
    with BMS.Canvas do begin
      Pen.Color   := clWhite;
      Rectangle(0,0,nx,ny);
    end;
    Image2.Picture.Assign(BMS);

    // apagamos la bandera de seleccion
    bsel := false;

    // Colocamos a Image2 ( recordar que es transparente y est encima
    // de Image1
    Image2.Show;

    // prendemos la bandera de imagen abierta
    bopen := true;
  end;
end;

// Salvar Como  Archivo
procedure TForm1.Salvar1Click(Sender: TObject);
begin
  if bopen then begin
    SaveDialog1.Filter := gfx_files._SaveFilterString;
    SaveDialog1.FileName := nom;
    if SaveDialog1.Execute then begin
      nom := SaveDialog1.FileName;
      gfx_files.SaveBMPToAnyFile(BM1,nom,0,0);
    end;

  end;
end;

// Evento de Mover el cursor sobre el Image1
// El Image2 tiene asociado el mismo evento
procedure TForm1.Image1MouseMove(Sender: TObject;
   Shift: TShiftState;
   X, Y: Integer);
var
  Pix   : integer;
  r,g,b : byte;
begin
   Pix := Image1.Canvas.Pixels[X,Y];
   r := Pix and $FF;
   g := (Pix SHR 8 ) and $FF;
   b := (Pix SHR 16) and $FF;

   // escribir cooordenadas
   StatusBar1.Panels[0].Text := IntToStr(X);
   StatusBar1.Panels[1].Text := IntToStr(Y);

   // escribir composicion RGB
   StatusBar1.Panels[2].Text := IntToStr(r);
   StatusBar1.Panels[3].Text := IntToStr(g);
   StatusBar1.Panels[4].Text := IntToStr(b);
end;

// se ha salido uno del Image2
procedure TForm1.Image2MouseLeave(Sender: TObject);
begin
   // escribir cooordenadas
   StatusBar1.Panels[0].Text := '?';
   StatusBar1.Panels[1].Text := '?';

   // escribir composicion RGB
   StatusBar1.Panels[2].Text := '?';
   StatusBar1.Panels[3].Text := '?';
   StatusBar1.Panels[4].Text := '?';
end;

// Elegir si estamos en modo de Seleccion o NO
procedure TForm1.RadioGroup1Click(Sender: TObject);
var
  OP : integer;
begin
  OP := RadioGroup1.ItemIndex;
  case OP of
    0 : begin
          _x1 := 0; _y1 := 0;
          _x2 := BM1.Width; _y2 := BM1.Height;
          // limpiar y escalar zona de seleccion
           BMS.Width  := _x2;
           BMS.Height := _y2;
           with BMS.Canvas do begin
             Pen.Color   := clWhite;
             Rectangle(0,0,_x2,_y2);
           end;
           Image2.Picture.Assign(BMS);

           bTarSel := false;
           bsel    := false;
        end;
    1 : begin
          bTarSel := true;
        end;
  end;
end;

// Mouse Down sobre la imagen2
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if btarSel then begin
    // se toma la coordenada donde se realiz el Click
    _x1 := X;
    _y1 := Y;
    bsel := true;
  end;
end;

// Mouse Up sobre la imagen2
procedure TForm1.Image2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Tx,Ty  : integer;
  a,b    : integer;
begin
  if bsel then begin

     // Intercambiar puntos para garantizar que
     // _x1 < _x2
     // _y1 < _y2

     // se toma la coordenada donde se suelta el Click
     _x2 := X;
     _y2 := Y;

     // calculamos el mayor y menor entre _x1 y _x2
     a := MIN(_x1, _x2);
     b := MAX(_x1, _x2);
     // se asocia el mnimo a _x1
     _x1 := a;
     // se asocia el mayor a _x2
     _x2 := b;

     // se procede igual con los valores de _y1 y _y2
     a := MIN(_y1, _y2);
     b := MAX(_y1, _y2);
     _y1 := a;
     _y2 := b;

     // se pinta el rectangulo de seleccion sobre el BitMap
     Tx := BM1.Width;
     Ty := BM1.Height;
     BMS.Width  := Tx;
     BMS.Height := Ty;
     with BMS.Canvas do begin
       Pen.Color   := clWhite;
       Rectangle(0,0,Tx,Ty);
       Pen.Color := clYellow;
       Rectangle(_x1,_y1,_x2,_y2);
     end;
     Image2.Picture.Assign(BMS);
     bsel := false;
  end;
end;

// Deshacer
procedure TForm1.Deshacer1Click(Sender: TObject);
begin
  if (M2.nc+M2.nr) > 0 then begin
    Intercambio (M1,M2);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;
end;

// Canales activos
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  kan[0] := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  kan[1] := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  kan[2] := CheckBox3.Checked;
end;

// --- Filtros Puntuales -----------------------

// Negativo
procedure TForm1.Negativo1Click(Sender: TObject);
begin
  // Se hace la copia de M2 en M1 en caso de que ya se haya realizado
  // algn proceso
  if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

  // se procesa M1 y el resultado queda en M2
  FP_Negativo(M1,M2);
  // se copia M2 al BitMap BM1
  Mat2BM(M2,BM1);
  // Se pasa el BM1 al Image1 de la Interface para visualizarla 
  Image1.Picture.Assign(BM1);
end;

// Corrimiento constante
procedure TForm1.Suma1Click(Sender: TObject);
var
  blec  : single;
begin
  // se muestra la forma de captura del valor del incremento
  Form2.ShowModal;

  // si la forma regresa el valor de OK (es decir se oprimi el botn de OK)
  // entonces se procesa la imagen con el filtro
  if Form2.ModalResult = mrOK then begin
    // se toma el valor del incremento de la forma auxiliar "Form2"
    blec := Form2.b;

    if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

    FP_Suma(M1,M2,blec);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;
end;

// Gamma
procedure TForm1.Gamma1Click(Sender: TObject);
var
  blec  : single;
begin
  Form2.ShowModal;

  if Form2.ModalResult = mrOK then begin
    blec := Form2.b;

    if (M2.nc+M2.nr) > 0 then Mat2Mat(M2,M1);

    FP_Gamma(M1,M2,blec);
    Mat2BM(M2,BM1);
    Image1.Picture.Assign(BM1);
  end;
end;

end.
